"use strict";
cc._RF.push(module, '10cb3j+O5RAa5U9wtXAoc+z', 'input-assembler');
// ParticleSystem/input-assembler.js

"use strict";

exports.__esModule = true;
exports["default"] = void 0;

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

// Copyright (c) 2017-2018 Xiamen Yaji Software Co., Ltd.
var gfx = cc.gfx;

var InputAssembler = /*#__PURE__*/function () {
  function InputAssembler(vb, ib, pt) {
    if (pt === void 0) {
      pt = gfx.PT_TRIANGLES;
    }

    this._vertexBuffer = vb;
    this._indexBuffer = ib;
    this._primitiveType = pt;
    this._start = 0;
    this._count = -1; // TODO: instancing data
    // this._stream = 0;
  }
  /**
   * @property {Number} count The number of indices or vertices to dispatch in the draw call.
   */


  _createClass(InputAssembler, [{
    key: "count",
    get: function get() {
      if (this._count !== -1) {
        return this._count;
      }

      if (this._indexBuffer) {
        return this._indexBuffer.count;
      }

      if (this._vertexBuffer) {
        return this._vertexBuffer.count;
      }

      return 0;
    }
  }]);

  return InputAssembler;
}();

exports["default"] = InputAssembler;
module.exports = exports["default"];

cc._RF.pop();